/*
 * 创客分润补贴月汇总
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class UserProfitSubsidySummaryController : BaseController
    {
        public UserProfitSubsidySummaryController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 创客分润补贴月汇总列表

        /// <summary>
        /// 根据条件查询创客分润补贴月汇总列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(UserProfitSubsidySummary data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            List<KqProducts> Brands = db.KqProducts.OrderBy(m => m.Id).ToList();
            ViewBag.Brands = Brands;

            return View();
        }

        #endregion

        #region 根据条件查询创客分润补贴月汇总列表

        /// <summary>
        /// 创客分润补贴月汇总列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(UserProfitSubsidySummary data, string MakerCode, string RealName, string TradeMonthSelect, string CheckStatusSelect, int page = 1, int limit = 30)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("BrandId", "0"); //品牌

            string condition = " and Status>-1";
            //直属创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //直属创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //是否验证
            if(!string.IsNullOrEmpty(CheckStatusSelect))
            {
                condition += " and CheckStatus=" + CheckStatusSelect;
            }
            //交易月份
            if(!string.IsNullOrEmpty(TradeMonthSelect))
            {
                condition += " and TradeMonth=" + TradeMonthSelect.Replace("-", "");
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserProfitSubsidySummary", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                dic["CheckStatus"] = dic["CheckStatus"].ToString() == "1" ? "已验证和同步" : "初始";
            }
            Dictionary<string, object> other = new Dictionary<string, object>();
            other.Add("SubsidyTotalProfit", 0);
            obj.Add("other", other);
            return Json(obj);
        }

        #endregion

        #region 增加创客分润补贴月汇总

        /// <summary>
        /// 增加或修改创客分润补贴月汇总信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加创客分润补贴月汇总

        /// <summary>
        /// 增加或修改创客分润补贴月汇总信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(UserProfitSubsidySummary data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("UserProfitSubsidySummary", Fields, 0);
            AddSysLog(data.Id.ToString(), "UserProfitSubsidySummary", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改创客分润补贴月汇总

        /// <summary>
        /// 增加或修改创客分润补贴月汇总信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            UserProfitSubsidySummary editData = db.UserProfitSubsidySummary.FirstOrDefault(m => m.Id == Id) ?? new UserProfitSubsidySummary();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改创客分润补贴月汇总

        /// <summary>
        /// 增加或修改创客分润补贴月汇总信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(UserProfitSubsidySummary data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserProfitSubsidySummary", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "UserProfitSubsidySummary", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除创客分润补贴月汇总信息

        /// <summary>
        /// 删除创客分润补贴月汇总信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserProfitSubsidySummary", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserProfitSubsidySummary", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserProfitSubsidySummary", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserProfitSubsidySummary", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserProfitSubsidySummary", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserProfitSubsidySummary", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("UserProfitSubsidySummary", Sort, Id);

            AddSysLog(Id.ToString(), "UserProfitSubsidySummary", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.UserProfitSubsidySummary.Add(new UserProfitSubsidySummary()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "UserProfitSubsidySummary", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(UserProfitSubsidySummary data, string MakerCode, string RealName, string TradeMonthSelect, string CheckStatusSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("BrandId", "0"); //品牌

            string condition = " and Status>-1";
            //直属创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //直属创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //是否验证
            if(!string.IsNullOrEmpty(CheckStatusSelect))
            {
                condition += " and CheckStatus=" + CheckStatusSelect;
            }
            //交易月份
            if(!string.IsNullOrEmpty(TradeMonthSelect))
            {
                condition += " and TradeMonth=" + TradeMonthSelect.Replace("-", "");
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserProfitSubsidySummary", Fields, "Id desc", "0", 1, 20000, condition, "UserId,BrandId,TradeMonth,SubsidyTotalProfit,SubsidyJuniorProfit,SubsidyDirectProfit,CheckStatus", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                dic["CheckStatus"] = dic["CheckStatus"].ToString() == "1" ? "已验证和同步" : "初始";
                dic.Remove("UserId");
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("MakerCode", "补贴创客编码");
            ReturnFields.Add("RealName", "补贴创客姓名");
            ReturnFields.Add("TradeMonth", "交易月份");
            ReturnFields.Add("BrandId", "产品类型");
            ReturnFields.Add("SubsidyTotalProfit", "商户");
            ReturnFields.Add("SubsidyJuniorProfit", "下级创客直属商户");
            ReturnFields.Add("SubsidyDirectProfit", "直营商户");
            ReturnFields.Add("CheckStatus", "验证和同步");
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "UserProfitSubsidySummary", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
